# Contextual replies



Contextual replies are a special way of responding to a WhatsApp user message. Sending a message as a contextual reply makes it clearer to the user which message you are replying to by quoting the previous message in a contextual bubble:

## Limitations

- You cannot send a [reaction message](https://developers.facebook.com/documentation/business-messaging/whatsapp/messages/reaction-messages) as a contextual reply.

The contextual bubble does not appear at the top of the delivered message if:

- The previous message has been deleted or moved to long term storage (messages are typically moved to long term storage after 30 days, unless you have enabled [local storage](https://developers.facebook.com/documentation/business-messaging/whatsapp/local-storage)).
- You reply with an [audio](https://developers.facebook.com/documentation/business-messaging/whatsapp/messages/audio-messages), [image](https://developers.facebook.com/documentation/business-messaging/whatsapp/messages/image-messages), or [video message](https://developers.facebook.com/documentation/business-messaging/whatsapp/messages/video-messages) and the WhatsApp user is running KaiOS.
- You use the WhatsApp client to reply with a [push-to-talk](https://faq.whatsapp.com/657157755756612/?cms_platform=web) message and the WhatsApp user is running KaiOS.
- You reply with a [template message](https://developers.facebook.com/documentation/business-messaging/whatsapp/templates/overview).

## Request syntax

```https
POST /<WHATSAPP_BUSINESS_PHONE_NUMBER_ID>/messages
```


### Post body

```json
{
  "messaging_product": "whatsapp",
  "recipient_type": "individual",
  "to": "<WHATSAPP_USER_PHONE_NUMBER>",
  "context": {
    "message_id": "WAMID_TO_REPLY_TO"
  },

  /* Message type and type contents goes here */

}
```

### Post body parameters

| Placeholder | Description | Example Value |
| --- | --- | --- |
| `<WAMID_TO_REPLY_TO>`<br><br>_String_ | **Required.**<br><br>WhatsApp message ID (wamid) of the previous message you want to reply to. | `wamid.HBgLMTY0NjcwNDM1OTUVAgASGBQzQTdCNTg5RjY1MEMyRjlGMjRGNgA=` |
| `<WHATSAPP_USER_PHONE_NUMBER>`<br><br>_String_ | **Required.**<br><br>WhatsApp user phone number. | `+16505551234` |

## Example request

Example of a text message sent as a reply to a previous message.

```curl
curl 'https://graph.facebook.com/v19.0/106540352242922/messages' \
-H 'Content-Type: application/json' \
-H 'Authorization: Bearer EAAJB...' \
-d '
{
  "messaging_product": "whatsapp",
  "recipient_type": "individual",
  "to": "+16505551234",
  "context": {
    "message_id": "wamid.HBgLMTY0NjcwNDM1OTUVAgASGBQzQTdCNTg5RjY1MEMyRjlGMjRGNgA="
  },
  "type": "text",
  "text": {
    "body": "You're welcome, Pablo!"
  }
}'
```